package com.tmax.openframe;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.file.*;
import com.tmax.openframe.variable.TEMPCOB_VariableContainer;
import com.tmax.openframe.variable.group.*;
import java.lang.Runnable;
import java.math.*;
import java.util.*;
import lombok.*;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 * <dl>
 * </dl>
 * <p>This describes files what declared in I/O sections: </p>
 * <ul>
 * <li>
 * IN01: file class {@code ->} {@link TEMPCOB_FD_IN01}, record class {@code -> } {@link TEMPCOB_SAMPLE}
 * <p>organization type: FILE_ORG_SEQUENTIAL</p>
 * <p>key: no key</p>
 * </li>
 * <li>
 * IN02: file class {@code ->} {@link TEMPCOB_FD_IN02}, record class {@code -> } {@link TEMPCOB_SAMPLE}
 * <p>organization type: FILE_ORG_SEQUENTIAL</p>
 * <p>key: no key</p>
 * </li>
 * <li>
 * IN03: file class {@code ->} {@link TEMPCOB_FD_IN03}, record class {@code -> } {@link TEMPCOB_SAMPLE}
 * <p>organization type: FILE_ORG_SEQUENTIAL</p>
 * <p>key: no key</p>
 * </li>
 * <li>
 * IN04: file class {@code ->} {@link TEMPCOB_FD_IN04}, record class {@code -> } {@link TEMPCOB_SAMPLE}
 * <p>organization type: FILE_ORG_SEQUENTIAL</p>
 * <p>key: no key</p>
 * </li>
 * <li>
 * OUT01: file class {@code ->} {@link TEMPCOB_FD_OUT01}, record class {@code -> } {@link TEMPCOB_OUT01}
 * <p>organization type: FILE_ORG_SEQUENTIAL</p>
 * <p>key: no key</p>
 * </li>
 * <li>
 * OUT02: file class {@code ->} {@link TEMPCOB_FD_OUT02}, record class {@code -> } {@link TEMPCOB_OUT02}
 * <p>organization type: FILE_ORG_SEQUENTIAL</p>
 * <p>key: no key</p>
 * </li>
 * <li>
 * OUT03: file class {@code ->} {@link TEMPCOB_FD_OUT03}, record class {@code -> } {@link TEMPCOB_OUT03}
 * <p>organization type: FILE_ORG_SEQUENTIAL</p>
 * <p>key: no key</p>
 * </li>
 * </ul>
 */
public class TEMPCOB implements Runnable {
    private @Getter Integer returnValue = 0;
    private @Getter TEMPCOB_VariableContainer container = new TEMPCOB_VariableContainer();
    TEMPCOB_FD_IN01 FD_IN01;
    TEMPCOB_FD_IN02 FD_IN02;
    TEMPCOB_FD_IN03 FD_IN03;
    TEMPCOB_FD_IN04 FD_IN04;
    TEMPCOB_FD_OUT01 FD_OUT01;
    TEMPCOB_FD_OUT02 FD_OUT02;
    TEMPCOB_FD_OUT03 FD_OUT03;
    Runnable UnnamedSentence = this::UnnamedSentence;
    Runnable GoTo;
    boolean Return;
    ArrayList<Runnable> MethodFlow = new ArrayList<>();
    {
        MethodFlow.add(UnnamedSentence);
    }

    public TEMPCOB() {
        FD_IN01 = new TEMPCOB_FD_IN01();
        FD_IN02 = new TEMPCOB_FD_IN02();
        FD_IN03 = new TEMPCOB_FD_IN03();
        FD_IN04 = new TEMPCOB_FD_IN04();
        FD_OUT01 = new TEMPCOB_FD_OUT01();
        FD_OUT02 = new TEMPCOB_FD_OUT02();
        FD_OUT03 = new TEMPCOB_FD_OUT03();
    }

    public @Override void run() {
        run(UnnamedSentence);
    }

    private void run(Runnable start) {
        run(start, null);
    }

    private void run(Runnable start, Runnable end) {
        List<Runnable> runList;
        if (end == null) {
            runList = Collections.singletonList(start);
        } else {
            runList = MethodFlow.subList(MethodFlow.indexOf(start),
                    MethodFlow.indexOf(end) + 1);
        }
        int i = 0;
        while (i < runList.size()) {
            runList.get(i).run();
            if (GoTo != null) {
                for (Runnable runUnit : runList) {
                    if (GoTo == runUnit) {
                        i = runList.indexOf(runUnit);
                        GoTo = null;
                        break;
                    }
                }
                if (GoTo != null) {
                    return;
                }
            } else {
                i++;
            }
            if (Return) {
                return;
            }
        }
    }

    public void init() {
        container = new TEMPCOB_VariableContainer();
        FD_IN01 = new TEMPCOB_FD_IN01();
        FD_IN02 = new TEMPCOB_FD_IN02();
        FD_IN03 = new TEMPCOB_FD_IN03();
        FD_IN04 = new TEMPCOB_FD_IN04();
        FD_OUT01 = new TEMPCOB_FD_OUT01();
        FD_OUT02 = new TEMPCOB_FD_OUT02();
        FD_OUT03 = new TEMPCOB_FD_OUT03();
    }

    void UnnamedSentence() {
        FD_IN01.close();
        FD_IN02.close();
        FD_IN03.close();
        FD_IN04.close();
        FD_OUT01.close();
        FD_OUT02.close();
        FD_OUT03.close();
        Return = true;
        return;
    }
}
